# Association Rules Discovery of Deviant Events in Multivariate Time Series: An Analysis and Implementation of the SAX-ARM Algorithm

Python implementation of a paper from Park et. al. (2019): SAX-ARM: Deviant event pattern discovery from multivariate time series using symbolic aggregate approximation and association rule mining.

This code provides a dataset as example (Wheather & Electricity Consumption). It describes the electricity consumption in different French cities based on the regional and national weather conditions

The interested user also has the ability to import their own dataset:
* The dataset must either be a .csv file or .txt file,
* The separator must be ',',
* A header must be present
* The first column should be a column called 't' with the timestamps of each sample.
* NaNs should be avoided, but the demo might still run if a small number of those are present.

Requirements: see Dockerfile and requirements.txt

Use:
`python main.py -w $WINDOW_SIZE -a $A -s $MIN_SUPP -c $MIN_CONF -i $I_PLOT example.csv`
where
* $WINDOW_SIZE Nis the number of time segments for the PAA. w should be less than the length of the time series
* $A is the alphabet size for the SAX discretization
* $MIN_SUPP is the minimum support for the Apriori algorithm
* $MIN_CONF is the minimum confidence for the Apriori algorithm
* $I_PLOT is the ID number of the column to plot.

Provided under the **BSD 3-Clause license**. Please see the enclosed file for details.
